<?php
// -------------------------------------------------------------
// -- pmxblog_install.php                                     --
// -------------------------------------------------------------
// -- Version: 0.953 for SMF 2.0                              --
// -- Copyright 2009-2010 by: PortaMx corp.                   --
// -- Support and Updates at: http://portamx.com              --
// -------------------------------------------------------------

global $modSettings, $db_name, $db_prefix, $user_info;

// Load the SSI.php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
{
	require_once(dirname(__FILE__) . '/SSI.php');

	// on manual installation you have to logged in
	if(!$user_info['is_admin']) 
	{
		if($user_info['is_guest']) 
		{
			echo '<b>', $txt['admin_login'],':</b><br />';
			ssi_login($boardurl.'/dbinstall.php');
			die();
		}
		else 
		{
			loadLanguage('Errors');
			fatal_error($txt['cannot_admin_forum']);
		}
	}
}
// no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> SSI.php not found. Please verify you put this in the same place as SMF\'s index.php.');

// Load the SMF DB Functions
db_extend('packages');
db_extend('extra');

// check if called with SSI
$isSSI = false;
if(eval("return sprintf('%s', SMF);") == 'SSI')
	$isSSI = true;

// =====================
// setup the defaults
// =====================

// prepare data
$Version = 'v0.953';
$cpy = '<a href="http://portamx.com" target="_blank">PortaMx Blog Extension '.$Version.'</a> | <a href="http://portamx.com/license" target="_blank">PmxBlog &copy; 2008-2010 by PortaMx corp.</a>';

// pepare the data array
$settings_data = array(
	'settings' => '60,20,20,0,0,10,0,2',
	'wysiwyg_edit' => 'a:1:{i:0;s:1:"1";}',
	'wysiwyg_comment' => 'a:1:{i:0;s:1:"1";}',
	'modgroups' => 'a:0:{}',
	'blog_acs' => ',:,:,',
	'blogadmin' => '1',
	'thumb_show' => '1',
	'thumb_size' => '100,75',
	'htmltags' => 'div|span|pre|p|h1|h2|h3|h4|h5|h6|blockquote|code|address',
	'copyright' => $cpy,
);

//==============================
// Check table update necessary
//==============================

// Table rename defs
$blog_Tables = array(
	'pmxblog_settings' => 'felblog_settings',
	'pmxblog_manager' => 'felblog_manager', 
	'pmxblog_ratings' => 'felblog_ratings', 
	'pmxblog_categories' => 'felblog_categories', 
	'pmxblog_content' => 'felblog_content', 
	'pmxblog_comments' => 'felblog_comments', 
	'pmxblog_cont_log' => 'felblog_cont_log'
);

// get a table list
$table_list= $smcFunc['db_list_tables']($db_name, '%felblog%');
$tbl_prefix = explode('.', $db_prefix);
if(isset($tbl_prefix[1]))
	$tbl_prefix = $tbl_prefix[1];
else
	$tbl_prefix = $db_prefix;

if(!empty($table_list) && in_array($tbl_prefix .'felblog_cmnt_log', $table_list))
{
	// drop the old comment log table
	$smcFunc['db_query']('security_override', '
		DROP TABLE {db_prefix}felblog_cmnt_log',
		array()
	);
}

// rename tables
if(!empty($table_list))
{
	foreach($blog_Tables as $newname => $tblname)
	{
		if(!empty($table_list) && in_array($tbl_prefix . $tblname, $table_list))
		{
			if($isSSI)
				echo 'Rename table: '. $tblname .' to '. $newname .'<br />';

			$smcFunc['db_query']('security_override', '
				RENAME TABLE {db_prefix}'. $tblname .' TO {db_prefix}'. $newname .'' ,
				array()
			);
		}
		elseif($isSSI)
			echo 'Table '. $tblname .' not exist.<br />';
	}
}

// =============================
// continue normal install
// =============================
$isUTF = '';
$req = $smcFunc['db_query']('', "
		SELECT value
		FROM {db_prefix}settings 
		WHERE variable = 'global_character_set' AND value = 'UTF-8'",
	array()
);
if($smcFunc['db_num_rows']($req) > 0)
{
	$isUTF = ' CHARACTER SET utf8'; 
	$smcFunc['db_free_result']($req);
}

// PmxBlog Table defs
$pmxblog_Tables = array(
	'pmxblog_settings' => 
		'CREATE TABLE {db_prefix}pmxblog_settings (
			ID int(10) unsigned NOT NULL auto_increment,
			name varchar(25) NOT NULL,
			value tinytext NOT NULL,
			PRIMARY KEY  (ID)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_manager' => 
		'CREATE TABLE {db_prefix}pmxblog_manager (
			owner int(11) NOT NULL default 0,
			blogname tinytext NOT NULL,
			blogdesc tinytext NOT NULL,
			showarchive tinyint(4) NOT NULL default 0,
			showcategories tinyint(4) NOT NULL default 0,
			showcalendar tinyint(4) NOT NULL default 0,
			blogcreated int(11) NOT NULL default 0,
			hidebaronedit int(11) NOT NULL default 0,
			blogenabled tinyint(4) NOT NULL default 0,
			bloglocked tinyint(4) NOT NULL default 0,
			tracking tinytext NOT NULL,
			blograting decimal(3,1) NOT NULL default 0.0,
			blogvotes int(11) NOT NULL default 0,
			settings varchar(10) NOT NULL,
			userpicture tinytext NOT NULL,
			PRIMARY KEY (owner)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_ratings' => 
		'CREATE TABLE {db_prefix}pmxblog_ratings (
			owner int(11) NOT NULL default 0,
			contID int(11) NOT NULL default 0,
			rating text NOT NULL,
			voter text NOT NULL,
			UNIQUE KEY contID (contID),
			KEY owner (owner)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_categories' => 
		'CREATE TABLE {db_prefix}pmxblog_categories (
			ID int(11) NOT NULL auto_increment,
			owner int(11) NOT NULL default 0,
			name tinytext NOT NULL,
			corder int(11) NOT NULL default 0,
			depth tinyint(4) NOT NULL default 0,
			PRIMARY KEY  (ID),
			KEY owner (owner),
			KEY corder (corder)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_content' => 
		'CREATE TABLE {db_prefix}pmxblog_content (
			ID int(10) unsigned NOT NULL auto_increment,
			owner int(10) unsigned NOT NULL default 0,
			ip_address varchar(16) NOT NULL,
			categorie int(10) unsigned NOT NULL default 0,
			nbr_comment tinyint(4) NOT NULL default 0,
			allowcomment tinyint(4) NOT NULL default 0,
			allow_view tinyint(4) NOT NULL default 0,
			date_created int(11) NOT NULL default 0,
			date_lastedit int(11) NOT NULL default 0,
			published tinyint(4) NOT NULL default 0,
			notify tinyint(4) NOT NULL default 0,
			views int(10) unsigned NOT NULL default 0,
			subject tinytext NOT NULL,
			body text NOT NULL,
			PRIMARY KEY  (ID),
			KEY owner (owner),
			KEY categorie (categorie),
			KEY date_created (date_created)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_comments' => 
		'CREATE TABLE {db_prefix}pmxblog_comments (
			ID int(10) unsigned NOT NULL auto_increment,
			author int(10) unsigned NOT NULL default 0,
			username varchar(25) NOT NULL,
			ip_address varchar(16) NOT NULL,
			contID int(10) unsigned NOT NULL default 0,
			parent int(10) unsigned NOT NULL default 0,
			treelevel tinyint(3) unsigned NOT NULL default 0,
			treeS2 int(10) unsigned NOT NULL default 0,
			date_created int(11) NOT NULL default 0,
			date_lastedit int(11) NOT NULL default 0,
			subject tinytext NOT NULL,
			body text NOT NULL,
			PRIMARY KEY  (ID),
			KEY owner (author),
			KEY parent (contID),
			KEY sub_parent (parent),
			KEY date_created (date_created)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_cmnt_log' => 
		'CREATE TABLE {db_prefix}pmxblog_cmnt_log (
			userID int(10) unsigned NOT NULL default 0,
			contID int(10) unsigned NOT NULL default 0,
			cmtID int(10) unsigned NOT NULL default 0,
			KEY userID (userID),
			KEY contID (contID)
		) TYPE=MyISAM'. $isUTF,

	'pmxblog_cont_log' => 
		'CREATE TABLE {db_prefix}pmxblog_cont_log (
			owner int(10) unsigned NOT NULL default 0,
			userID int(10) unsigned NOT NULL default 0,
			is_read tinytext NOT NULL,
			KEY userID (userID),
			KEY owner (owner)
		) TYPE=MyISAM'. $isUTF,
);

// get a table list
$table_list = $smcFunc['db_list_tables']($db_name, '%pmxblog%');
$created = array();

$tbl_prefix = explode('.', $db_prefix);
if(isset($tbl_prefix[1]))
	$tbl_prefix = $tbl_prefix[1];
else
	$tbl_prefix = $db_prefix;

foreach($pmxblog_Tables as $tblname => $tbldef)
{
	if(empty($table_list) || !in_array($tbl_prefix . $tblname, $table_list))
	{
		// create the table
		if($isSSI)
			echo 'Create table: '. $tblname .'.<br />';

		$created[] = $tblname;
		$smcFunc['db_query']('security_override',
			$tbldef,
			array()
		);
	}
	elseif($isSSI)
		echo 'Table '. $tblname .' allready exist.<br />';
}

// rename and change col typ in the manager table
$req = $smcFunc['db_query']('security_override', '
	SHOW COLUMNS FROM {db_prefix}pmxblog_manager LIKE {string:like}',
	array('like' => '%editor')
);
if($smcFunc['db_num_rows']($req) != 0)
{
	$smcFunc['db_free_result']($req);

	$smcFunc['db_query']('security_override', '
		ALTER TABLE {db_prefix}pmxblog_manager CHANGE editor settings VARCHAR(10) NOT NULL',
		array()
	);
}

// add 'notify' col to the content table
$req = $smcFunc['db_query']('security_override', '
	SHOW COLUMNS FROM {db_prefix}pmxblog_content LIKE {string:like}',
	array('like' => '%notify')
);
if($smcFunc['db_num_rows']($req) == 0)
{
	$smcFunc['db_free_result']($req);

	$smcFunc['db_query']('security_override', '
		ALTER TABLE {db_prefix}pmxblog_content ADD notify TINYINT NOT NULL DEFAULT 0 AFTER published',
		array()
	);

	$smcFunc['db_query']('', '
		UPDATE {db_prefix}pmxblog_content
			SET notify = published',
		array()
	);
}

// clear and reload settings
$result = array();
$req = $smcFunc['db_query']('security_override', '
		TRUNCATE TABLE {db_prefix}pmxblog_settings',
	array()
);

foreach($settings_data as $name => $value)
{
	$smcFunc['db_insert']('', '
		{db_prefix}pmxblog_settings',
		array(
			'name' => 'string',
			'value' => 'string'
		),
		array(
			$name,
			$value
		),
		array('ID')
	);
}

// enable PmxBlog
$req = $smcFunc['db_query']('', '
		SELECT variable, value 
		FROM {db_prefix}settings
		WHERE variable = {string:varname}',
	array(
		'varname' => 'pmxblog_enabled'
	)
);
if($smcFunc['db_num_rows']($req) > 0)
	$smcFunc['db_free_result']($req);
else
	$smcFunc['db_insert']('replace', '
		{db_prefix}settings',
		array(
			'variable' => 'string', 
			'value' => 'string'
		),
		array(
			'pmxblog_enabled',
			'1'
		),
		array('variable')
	);

if($isSSI)
	echo 'Done. <br />';
?>